-----------------------------------------------------------------------
--  gen-configs -- Configuration for code Generator
--  Copyright (C) 2009, 2010, 2011, 2012 Stephane Carrez
--  Written by Stephane Carrez (Stephane.Carrez@gmail.com)
--
--  Licensed under the Apache License, Version 2.0 (the "License");
--  you may not use this file except in compliance with the License.
--  You may obtain a copy of the License at
--
--      http://www.apache.org/licenses/LICENSE-2.0
--
--  Unless required by applicable law or agreed to in writing, software
--  distributed under the License is distributed on an "AS IS" BASIS,
--  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
--  See the License for the specific language governing permissions and
--  limitations under the License.
-----------------------------------------------------------------------

package Gen.Configs is

   VERSION                  : constant String := "0.7.0";
   RELEASE                  : constant String := "Dynamo Ada Generator " & "0.7.0" & " - Revision"
                              & Positive'Image (Gen.SVN_REV) & ", Stephane Carrez";
   GEN_PACKAGE_BODY         : constant String := "generator.template.package.body";
   GEN_PACKAGE_SPEC         : constant String := "generator.template.package.spec";
   GEN_MYSQL_SQL_FILE       : constant String := "generator.template.sql.mysql";
   GEN_SQLITE_SQL_FILE      : constant String := "generator.template.sql.sqlite";
   GEN_MYSQL_DROP_SQL_FILE  : constant String := "generator.template.drop.sql.mysql";
   GEN_SQLITE_DROP_SQL_FILE : constant String := "generator.template.drop.sql.sqlite";
   GEN_UML_DIR              : constant String := "generator.uml.dir";
   GEN_UML_DEFAULT_TYPE     : constant String := "generator.uml.default_type";
   GEN_DEBUG_ENABLE         : constant String := "generator.debug";
   GEN_GNAT_PROJECT_DIRS    : constant String := "generator.gnat.projects.dir";
   GEN_TEMPLATES_DIRS       : constant String := "generator.model.dir";

   --  Path of the config directory
   CONFIG_DIR               : constant String := "/build/install-4.6/share/dynamo/base";

end Gen.Configs;
